#include <Arduino.h>
#include <stdint.h>

#define led 13
//IC1 & IC2
#define AX0 14
#define AX1 15
#define AX2 16
#define AX3 17
#define AY0 18
#define AY1 19
#define AY2 20
#define reset 21

#define Data 23
#define strobe 22

#define cs1 40
#define cs2 39
#define cs3 38
#define cs4 37
#define cs5 36
#define cs6 35

int a = 0, b = 0, c = 2, b_n = 0, cs, mode;  //mode---> 1 >> AB; 2 >> AA; 3 >> BB;
int xArray[4], yArray[3];

void selectIc() {
  switch (mode) {
    case 1:
      if (b >= 8) {
        cs = cs2;
        // Serial.println("cs2");
      } else {
        cs = cs1;
        // Serial.println("cs1");
      }
      break;
    case 2:
      if (b >= 8) {
        cs = cs4;
        // Serial.println("cs4");
      } else {
        cs = cs3;
        // Serial.println("cs3");
      }
      break;
    case 3:
      if (b >= 8) {
        cs = cs6;
        // Serial.println("cs6");
      } else {
        cs = cs5;
        // Serial.println("cs5");
      }
      break;
  }
}

void setup() {
  pinMode(led, OUTPUT);
  pinMode(AX0, OUTPUT);
  pinMode(AX1, OUTPUT);
  pinMode(AX2, OUTPUT);
  pinMode(AX3, OUTPUT);
  pinMode(AY0, OUTPUT);
  pinMode(AY1, OUTPUT);
  pinMode(AY2, OUTPUT);
  pinMode(reset, OUTPUT);
  pinMode(Data, OUTPUT);
  pinMode(strobe, OUTPUT);
  pinMode(cs1, OUTPUT);
  pinMode(cs2, OUTPUT);
  pinMode(cs3, OUTPUT);
  pinMode(cs4, OUTPUT);
  pinMode(cs5, OUTPUT);
  pinMode(cs6, OUTPUT);

  digitalWrite(led, LOW);
  digitalWrite(AX0, LOW);
  digitalWrite(AX1, LOW);
  digitalWrite(AX2, LOW);
  digitalWrite(AX3, LOW);
  digitalWrite(AY0, LOW);
  digitalWrite(AY1, LOW);
  digitalWrite(AY2, LOW);
  digitalWrite(reset, LOW);
  digitalWrite(Data, LOW);
  digitalWrite(strobe, LOW);
  digitalWrite(cs1, LOW);
  digitalWrite(cs2, LOW);
  digitalWrite(cs3, LOW);
  digitalWrite(cs4, LOW);
  digitalWrite(cs5, LOW);
  digitalWrite(cs6, LOW);

  digitalWrite(reset, HIGH);
  delay(100);
  digitalWrite(reset, LOW);

  Serial.begin(115200);
  Serial.println("Input format. (x/y)<number> (x/y)<number> connect/disconnect");
}

void loop() {
  if (Serial.available() > 0) {
    
    digitalWrite(led, HIGH);
    delay(50);
    digitalWrite(led, LOW);
    delay(50);

    String data = Serial.readStringUntil('\n');
    data.trim();

    input(data.c_str());
    if (c == 1) {
      connectIt();
      Serial.print(data);
      Serial.print("\t\t");
      Serial.println("OK!");
      c = 2;
    } else if (c == 0) {
      disconnectIt();
      Serial.print(data);
      Serial.print("\t");
      Serial.println("OK!");
      c = 2;
    }
  }
}

void input(const char *data) {
  char command[12];

  if (sscanf(data, "x%d y%d %11s", &a, &b, command) == 3) {
    mode = 1;
    if (strcmp(command, "connect") == 0) c = 1;
    else if (strcmp(command, "disconnect") == 0) c = 0;
    else {
      Serial.print(data);
      Serial.print("! ");
      Serial.println("Invalid input format. Please use: (x/y)<number> (x/y)<number> connect/disconnect");
    }
  } else if (sscanf(data, "y%d x%d %11s", &b, &a, command) == 3) {
    mode = 1;
    if (strcmp(command, "connect") == 0) c = 1;
    else if (strcmp(command, "disconnect") == 0) c = 0;
    else {
      Serial.print(data);
      Serial.print("! ");
      Serial.println("Invalid input format. Please use: (x/y)<number> (x/y)<number> connect/disconnect");
    }
  } else if (sscanf(data, "x%d x%d %11s", &a, &b, command) == 3) {
    mode = 2;
    if (strcmp(command, "connect") == 0) c = 1;
    else if (strcmp(command, "disconnect") == 0) c = 0;
    else {
      Serial.print(data);
      Serial.print("! ");
      Serial.println("Invalid input format. Please use: (x/y)<number> (x/y)<number> connect/disconnect");
    }
  } else if (sscanf(data, "y%d y%d %11s", &a, &b, command) == 3) {
    mode = 3;
    if (strcmp(command, "connect") == 0) c = 1;
    else if (strcmp(command, "disconnect") == 0) c = 0;
    else {
      Serial.print(data);
      Serial.print("! ");
      Serial.println("Invalid input format. Please use: (x/y)<number> (x/y)<number> connect/disconnect");
    }
  } else {
    Serial.print(data);
    Serial.print("! ");
    Serial.println("Invalid input format. Please use: (x/y)<number> (x/y)<number> connect/disconnect");
  }

  if (a == 12 || a == 13) a -= 6;
  else if (a >= 6 && a <= 11) a += 2;

  if (b >= 8) b_n = b - 8;
  else b_n = b;

  xArray[0] = (a & B00001000) >> 3;
  xArray[1] = (a & B00000100) >> 2;
  xArray[2] = (a & B00000010) >> 1;
  xArray[3] = (a & B00000001);

  yArray[0] = (b_n & B00000100) >> 2;
  yArray[1] = (b_n & B00000010) >> 1;
  yArray[2] = (b_n & B00000001);
}

void connectIt() {
  selectIc();
  digitalWrite(cs, HIGH);

  addressWrite();
  delayMicroseconds(100);


  digitalWrite(strobe, HIGH);
  delayMicroseconds(10);
  digitalWrite(Data, HIGH);
  delayMicroseconds(10);
  digitalWrite(strobe, LOW);
  delayMicroseconds(10);

  digitalWrite(AX3, LOW);
  digitalWrite(AX2, LOW);
  digitalWrite(AX1, LOW);
  digitalWrite(AX0, LOW);
  digitalWrite(AY2, LOW);
  digitalWrite(AY1, LOW);
  digitalWrite(AY0, LOW);

  digitalWrite(Data, LOW);
  delayMicroseconds(10);

  digitalWrite(cs, LOW);
  addressLow();
}

void disconnectIt() {
  selectIc();
  digitalWrite(cs, HIGH);

  addressWrite();
  delayMicroseconds(100);

  digitalWrite(Data, LOW);
  delayMicroseconds(10);
  digitalWrite(strobe, HIGH);
  delayMicroseconds(10);
  digitalWrite(strobe, LOW);
  delayMicroseconds(10);

  digitalWrite(cs, LOW);
  addressLow();
}

void addressWrite() {
  digitalWrite(AX3, xArray[0]);
  digitalWrite(AX2, xArray[1]);
  digitalWrite(AX1, xArray[2]);
  digitalWrite(AX0, xArray[3]);
  digitalWrite(AY2, yArray[0]);
  digitalWrite(AY1, yArray[1]);
  digitalWrite(AY0, yArray[2]);
  // //address check
  // Serial.print("AX0: ");
  // Serial.println(xArray[3]);
  // Serial.print("AX1: ");
  // Serial.println(xArray[2]);
  // Serial.print("AX2: ");
  // Serial.println(xArray[1]);
  // Serial.print("AX3: ");
  // Serial.println(xArray[0]);

  // Serial.print("AY0: ");
  // Serial.println(yArray[2]);
  // Serial.print("AY1: ");
  // Serial.println(yArray[1]);
  // Serial.print("AY2: ");
  // Serial.println(yArray[0]);
}

void addressLow() {
  digitalWrite(AX3, LOW);
  digitalWrite(AX2, LOW);
  digitalWrite(AX1, LOW);
  digitalWrite(AX0, LOW);
  digitalWrite(AY2, LOW);
  digitalWrite(AY1, LOW);
  digitalWrite(AY0, LOW);
}
